SystemOrganization addCategory: #'ObjectLand-Core'!

Object subclass: #OLContinuation
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectLand-Core'!

!OLContinuation commentStamp: '<historical>' prior: 0!
Continuation class borrowed from Seaside
(author: Avi Bryant) !

!OLContinuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
current
	^ self fromContext: thisContext sender! !

!OLContinuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
currentDo: aBlock
	^ aBlock value: (self fromContext: thisContext sender)! !

!OLContinuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
fromContext: aStack
	^self new initializeFromContext: aStack! !

!OLContinuation methodsFor: 'private' stamp: 'GrahamKelly 10/19/2019 14:27'!
initializeFromContext: aContext
	| valueStream context |
	valueStream := WriteStream on: (Array new: 20).
	context := aContext.
	[context notNil] whileTrue:
		[valueStream nextPut: context.
		1 to: context class instSize do: [:i | valueStream nextPut: (context instVarAt: i)].
		1 to: context basicSize do: [:i | valueStream nextPut: (context basicAt: i)].
		context := context sender].
	values := valueStream contents! !

!OLContinuation methodsFor: 'testing' stamp: 'spfa 6/18/2006 22:14'!
isContinuation

	^ true! !

!OLContinuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:18'!
numArgs
	^ 1! !

!OLContinuation methodsFor: 'as yet unclassified' stamp: 'GrahamKelly 10/19/2019 14:26'!
restoreValues
	| valueStream context |
	valueStream := values readStream.
	[valueStream atEnd] whileFalse:
		[context := valueStream next.
		1 to: context class instSize do: [:i | context instVarAt: i put: valueStream next].
		1 to: context basicSize do: [:i | context basicAt: i put: valueStream next]]! !

!OLContinuation methodsFor: 'private' stamp: 'GrahamKelly 10/19/2019 14:27'!
terminate: aContext
	| context |
	context := aContext.
	[context notNil] whileTrue: [context := context swapSender: nil]
! !

!OLContinuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:13'!
value
	self value: nil! !

!OLContinuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:12'!
value: v
	self terminate: thisContext.
	self restoreValues.
	thisContext swapSender: values first.
	^v! !

!OLContinuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:22'!
valueWithArguments: v
	v size == 1 ifFalse: [^self error: 'continuations can only be resumed with one argument'].
	self value: v first! !

Object subclass: #OLDefaultUserServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectLand-Core'!

OLDefaultUserServer class
	instanceVariableNames: 'current all'!

OLDefaultUserServer class
	instanceVariableNames: 'current all'!

!OLDefaultUserServer class methodsFor: 'accessing' stamp: 'GDK 10/14/2019 01:56'!
all
	^all ifNil: [all := Set new]! !

!OLDefaultUserServer class methodsFor: 'accessing' stamp: 'GDK 10/14/2019 01:55'!
current

	^ current! !

!OLDefaultUserServer class methodsFor: 'accessing' stamp: 'GrahamKelly 10/19/2019 14:25'!
current: anObject
Smalltalk at: #SystemAnnouncer ifPresent: [ :c| c uniqueInstance announce: (OLLoggedInSomehow new user: anObject)].
	current := anObject.! !

Object subclass: #OLThemeSnapshot
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectLand-Core'!

!OLThemeSnapshot methodsFor: 'operations' stamp: 'GrahamKelly 10/19/2019 12:45'!
adopt: theme
	properties := Dictionary newFrom: (theme instVarNamed: #properties) ! !

!OLThemeSnapshot methodsFor: 'as yet unclassified' stamp: 'GrahamKelly 10/19/2019 12:46'!
applyOnto: theme
	theme instVarNamed: #properties put: properties.
	properties := Dictionary newFrom: properties.! !

Object subclass: #OLToolBarTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectLand-Core'!

OLToolBarTool subclass: #OLRemotingToolBarTool
	instanceVariableNames: 'broker'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectLand-Core'!

!OLRemotingToolBarTool methodsFor: 'as yet unclassified' stamp: 'GDK 10/13/2019 14:50'!
doMenuOn: menu
	broker doMenuOn: menu from: self.! !

!OLToolBarTool methodsFor: 'accessing' stamp: 'GrahamKelly 10/15/2019 16:18'!
icon
	^nil! !

Object subclass: #OLUser
	instanceVariableNames: 'connections getName setName getPassword'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectLand-Core'!

!OLUser class methodsFor: 'as yet unclassified' stamp: 'GrahamKelly 10/15/2019 16:17'!
named: n ifAbsent: b
	^self allSubInstances detect: [:i|[i name = n] on: (Smalltalk at: #NotImplemented ifAbsent: [ Smalltalk at: #ShouldNotImplement ]) do: [:ex|false]] ifNone: b! !

!OLUser methodsFor: 'accessing' stamp: 'GDK 10/13/2019 22:11'!
connections

	^ connections! !

!OLUser methodsFor: 'accessing' stamp: 'GDK 10/13/2019 22:11'!
connections: anObject

	connections := anObject.! !

!OLUser methodsFor: 'accessing' stamp: 'GDK 10/13/2019 22:11'!
getName

	^ getName! !

!OLUser methodsFor: 'accessing' stamp: 'GDK 10/13/2019 22:11'!
getName: anObject

	getName := anObject.! !

!OLUser methodsFor: 'accessing' stamp: 'GDK 10/13/2019 22:11'!
getPassword

	^ getPassword! !

!OLUser methodsFor: 'accessing' stamp: 'GDK 10/13/2019 22:11'!
getPassword: anObject

	getPassword := anObject.! !

!OLUser methodsFor: 'initialization' stamp: 'GDK 10/13/2019 22:53'!
initialize
	super initialize.
	connections := Set new.
	getName := getPassword := [self shouldNotImplement].
	setName := #shouldNotImplement.! !

!OLUser methodsFor: 'accessing' stamp: 'GDK 10/13/2019 22:13'!
name
	^getName value! !

!OLUser methodsFor: 'accessing' stamp: 'GDK 10/13/2019 22:13'!
name: t
	setName value: t! !

!OLUser methodsFor: 'accessing' stamp: 'GDK 10/13/2019 22:14'!
password
	^getPassword value! !

!OLUser methodsFor: 'accessing' stamp: 'GDK 10/13/2019 22:11'!
setName

	^ setName! !

!OLUser methodsFor: 'accessing' stamp: 'GDK 10/13/2019 22:11'!
setName: anObject

	setName := anObject.! !

Object subclass: #OLWelcome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectLand-Core'!

!OLWelcome methodsFor: 'as yet unclassified' stamp: 'GrahamKelly 10/20/2019 10:50'!
changeLanguage
	^'(change language)'! !

!OLWelcome methodsFor: 'lessons' stamp: 'GrahamKelly 10/20/2019 11:03'!
welcome
| cont1 |
	self inform: self welcomeText.
	cont1 := OLContinuation current.
	(self confirm: self changeLanguage) ifTrue: [ (UIManager default chooseFrom: self class withAllSubclasses) ifNotNil: [ :c|(self class withAllSubclasses at: c) adoptInstance: self. ^self welcome ] ].
	(self class == OLWelcome) ifFalse: [ (self confirm: 'If you understand, press Yes')  ifFalse: [cont1 value: 'return']]! !

!OLWelcome methodsFor: 'as yet unclassified' stamp: 'GrahamKelly 10/20/2019 10:45'!
welcomeText
	^'Welcome to ObjectLand'! !

!TransformMorph methodsFor: '*ObjectLand-Core' stamp: 'GDK 10/19/2019 15:46'!
widgetType
	^self firstSubmorph widgetType! !

RSTBroker subclass: #OLRSTBroker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectLand-Core'!

!OLRSTBroker methodsFor: 'as yet unclassified' stamp: 'GDK 10/13/2019 21:59'!
initialize
	super initialize.
	self export: self named: #_Broker.
	self export: [OLAI default instance] named: #_AI.
	self export: [OLContinuation current] named: #_Capture.! !

!HandMorph methodsFor: '*ObjectLand-Core' stamp: 'GDK 10/19/2019 15:45'!
widgetType
	^#hand! !

!Morph methodsFor: '*ObjectLand-Core' stamp: 'GDK 10/19/2019 15:44'!
widgetType
	^#eToy! !

Morph subclass: #OLWidgetMorph
	instanceVariableNames: 'stayUp isFlexMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectLand-Core'!

OLWidgetMorph subclass: #OLUnFullScreenMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectLand-Core'!

!OLUnFullScreenMorph methodsFor: 'as yet unclassified' stamp: 'GDK 10/20/2019 11:41'!
initialize
	super initialize.
	self on: #mouseUp send: #restore to: self.! !

!OLUnFullScreenMorph methodsFor: 'as yet unclassified' stamp: 'GDK 10/20/2019 11:40'!
restore
	Project current world submorphs do: [:s|(s respondsTo: #fillScreenOff) ifTrue: [s fillScreenOff]]! !

!OLWidgetMorph methodsFor: 'as yet unclassified' stamp: 'GDK 10/20/2019 16:14'!
comeToFront
self valueOfProperty: #modalChild ifPresentDo: [:mo|mo comeToFront].
stayUp ifFalse: [^super comeToFront].
owner owner ifNil: [^super comeToFront].
	owner comeToFront.
	super comeToFront! !

!OLWidgetMorph methodsFor: 'as yet unclassified' stamp: 'GDK 10/20/2019 16:20'!
initialize
isFlexMorph := false.
	super initialize.
	stayUp := true.! !

!OLWidgetMorph methodsFor: 'accessing' stamp: 'GDK 10/20/2019 16:19'!
isFlexMorph
	^isFlexMorph! !

!OLWidgetMorph methodsFor: 'accessing' stamp: 'GDK 10/20/2019 16:19'!
isFlexMorph: anObject

	isFlexMorph := anObject.! !

!OLWidgetMorph methodsFor: 'as yet unclassified' stamp: 'GDK 10/20/2019 16:35'!
renderedMorph
	self isFlexMorph ifFalse: [^self] ifTrue: [^self firstSubmorph renderedMorph]! !

!OLWidgetMorph methodsFor: 'accessing' stamp: 'GDK 10/20/2019 15:33'!
stayUp

	^ stayUp! !

!OLWidgetMorph methodsFor: 'accessing' stamp: 'GDK 10/20/2019 15:33'!
stayUp: anObject

	stayUp := anObject.! !

!OLWidgetMorph methodsFor: 'as yet unclassified' stamp: 'GDK 10/20/2019 15:34'!
step
	stayUp ifTrue: [self comeToFront]! !

!OLWidgetMorph methodsFor: 'as yet unclassified' stamp: 'GDK 10/20/2019 11:34'!
stepTime
	^0! !

!SystemWindow methodsFor: '*ObjectLand-Core' stamp: 'GDK 10/19/2019 15:45'!
widgetType
	^#window! !

AppRegistry subclass: #Calculator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectLand-Core'!

AppRegistry subclass: #OLAI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectLand-Core'!

AppRegistry subclass: #OLRuntime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectLand-Core'!

OLRuntime class
	instanceVariableNames: 'smalltalk js python'!

OLRuntime class
	instanceVariableNames: 'smalltalk js python'!

!OLRuntime class methodsFor: 'accessing' stamp: 'GDK 10/19/2019 17:46'!
baseGlobal: sel do: b
	^(self defaultOf: sel) ifNotNil: [:d|d globalDo: b]! !

!OLRuntime class methodsFor: 'accessing' stamp: 'GDK 10/19/2019 17:14'!
defaultOf: sel
	^(self get: sel) ifNotNil: #default! !

!OLRuntime class methodsFor: 'accessing' stamp: 'GDK 10/19/2019 17:14'!
defaultOf: sel is: v
	^(self get: sel) ifNotNil: [:r|r default: v]! !

!OLRuntime class methodsFor: 'accessing' stamp: 'GDK 10/19/2019 17:15'!
evaluateOf: sel text: t then: b
	^(self defaultOf: sel) ifNotNil: [:d|d evaluate: sel then: b]! !

!OLRuntime class methodsFor: 'accessing' stamp: 'GDK 10/19/2019 17:13'!
get: sel
	^(self perform: sel) ifNil: [self perform: sel, ':' with: self newSubclass]! !

!OLRuntime class methodsFor: 'accessing' stamp: 'GDK 10/19/2019 17:12'!
js

	^ js! !

!OLRuntime class methodsFor: 'accessing' stamp: 'GDK 10/19/2019 17:12'!
js: anObject

	js := anObject.! !

!OLRuntime class methodsFor: 'accessing' stamp: 'GDK 10/19/2019 17:12'!
python

	^ python! !

!OLRuntime class methodsFor: 'accessing' stamp: 'GDK 10/19/2019 17:12'!
python: anObject

	python := anObject.! !

!OLRuntime class methodsFor: 'accessing' stamp: 'GDK 10/19/2019 17:12'!
smalltalk

	^ smalltalk! !

!OLRuntime class methodsFor: 'accessing' stamp: 'GDK 10/19/2019 17:12'!
smalltalk: anObject

	smalltalk := anObject.! !
